//Find PreLogin and check what's at the end of said function


void UXC_GameEngine::ReplacePreLoginFunc( UBOOL bSet)
{
	guard(UXC_GameEngine::ReplacePreLoginFunc);

	UFunction* PreLogin = FindBaseFunction( AGameInfo::StaticClass(), TEXT("PreLogin"));
	if ( !PreLogin ) //Script not serialized?
		return;

	GNatives[3550] = (Native)&UObject::execUndefined;
	if ( OldPreLogin.IsCleared() && (!bSet || !OldPreLogin.Setup( &PreLogin->Script )) )
		return;
	
	if ( !bSet )
	{
		OldPreLogin.Restore( &PreLogin->Script);
		if ( bEnableDebugLogs )
			debugf( NAME_XC_Engine, TEXT("Reverting PreLogin hook") );
		return;
	}
	else if ( OldPreLogin.MismatchSize(&PreLogin->Script) )
		return;

	//Initialize remaining vars
	INT Found = 0;
	UProperty* Options = FindScriptVariable( PreLogin, TEXT("Options"), &Found);
	UProperty* Address = FindScriptVariable( PreLogin, TEXT("Address"), &Found);
	UProperty* Error = FindScriptVariable( PreLogin, TEXT("Error"), &Found);
	UProperty* FailCode = FindScriptVariable( PreLogin, TEXT("FailCode"), &Found);
	check( Found == 4 );
	
	PreLogin->Script.InsertZeroed( PreLogin->Script.Num()-2, 23 ); //Add 23 bytes right before the return
	BYTE* Block = &PreLogin->Script( PreLogin->Script.Num() - 25);

	GNatives[3550] = (Native)&AXC_DummyPawn::PreLoginNative;
	HighNative( Block, 3550);				Block += 2;
	ParseLocalVariable( Block, Options);	Block += 5;
	ParseLocalVariable( Block, Address);	Block += 5;
	ParseLocalVariable( Block, Error);		Block += 5;
	ParseLocalVariable( Block, FailCode);	Block += 5;
	*Block++ = 0x16; //EX_EndFunctionParms
	check( *Block == 0x04); //Beginning of return

	if ( bEnableDebugLogs )
		debugf( NAME_XC_Engine, TEXT("PreLogin hook success"));
	unguard;
}

//Called on GameInfo context
void AXC_DummyPawn::PreLoginNative(FFrame &Stack, RESULT_DECL)
{
	guard( PreLoginNative );
	P_GET_STR( Options);
	P_GET_STR( Address);
	P_GET_STR_REF( Error);
	P_GET_STR_REF( FailCode);
	P_FINISH;

	((UXC_GameEngine*)(XLevel->Engine))->ProcessPreLoginHooks( Options, Address, *Error, *FailCode);
	unguard;
}
//IMPLEMENT_FUNCTION( UXC_GameEngine,-1,PreLoginNative);

struct UHack_eventPreLoginHook_Parms
{
    FString Options;
    FString Address;
    FString Error;
    FString FailCode;
};

void UXC_GameEngine::ProcessPreLoginHooks(const FString& Options, const FString& Address, FString& Error, FString& FailCode)
{
	guard(ProcessPreLoginHooks);
	UHack_eventPreLoginHook_Parms Parms;
	Parms.Options=Options;
	Parms.Address=Address;
	Parms.Error=Error;
	Parms.FailCode=FailCode;
	FName NAME_PreLoginHook = FName( TEXT("PreLoginHook"), FNAME_Find); //Dynamically find name
	if ( NAME_PreLoginHook != NAME_None )
	{
		for ( int i=0 ; i<12 ; i++ )
			if ( PreLoginHooks[i]  )
			{
				if ( PreLoginHooks[i]->bDeleteMe )
					PreLoginHooks[i] = NULL;
				else
					PreLoginHooks[i]->ProcessEvent( PreLoginHooks[i]->FindFunctionChecked(NAME_PreLoginHook),&Parms);
			}
	}
	Error=Parms.Error;
	FailCode=Parms.FailCode;
	unguard;
}
